#!/usr/bin/perl
#$HeadURL: http://gruen.4g/svn/branches/stable-1.0/application/nylon-config/srv/www/cgi-bin/CWeb/PostVars.pm $ $LastChangedRevision: 701 $

package CWeb::PostVars;

sub new {
  my $proto = shift;
  my $class = ref($proto) || $proto;
  my $self = {};
  bless($self,$class);
  if ($ENV{"REQUEST_METHOD"} !~ /post/i) {
      $self->{ERROR} = "can handle only POST method";
      return $self;
  }
  $self->{"CONTENT_TYPE"} = $ENV{"CONTENT_TYPE"};
  if ($self->{"CONTENT_TYPE"} =~ m:multipart/form-data.*boundary=(.+)$:i) {
      $self->{_BOUNDARY} = $1;
      _suck_multipart($self);
  } else {
      _suck_plain($self);
  }
  return $self;
}

sub _suck_plain {
    my $self = shift;
    while(<>) {
	my @v = split /&/;
	foreach( @v ) {
	    split /=/;
	    $self->{FORM}->{@_[0]} = @_[1];
	}
    }
}

sub _suck_multipart {
    my $self = shift;
    my $boundary = $self->{_BOUNDARY};
    my $tmpfile = "/tmp/upload.tmp";
    my $file = "";		# set if processing file upload
    my $key = "";
  SUCK: while(<>) {
	if (/$boundary/) {
	    while (<>) {
		next SUCK if /^\s*$/;
		# rudimentary mime header processing
		if (/Content-Disposition: form-data;(.*)$/) {
		    my $formdesc = $1;
		    if ($formdesc =~ /\sname="([^"]+)"/) { # ignoring C-type
			$key = $1;
			if ($formdesc =~ /filename="([^"]+)"/) { #special: upload
			    $self->{FORM}->{$key}->{OFNAME} = $1;
			    $self->{FORM}->{$key}->{TMPFILE} = $tmpfile;
			    $file = $tmpfile;
			    open(OUT,">$tmpfile");
			} else { #normal key/value
			    close OUT if $file;
			    $file = "";
			    $self->{FORM}->{$key} = [];
			}
		    }
		}
	    }
	}			# end of mime processing
	if (defined $_) {
	    if ($file) {
		print OUT;
	    } else {
		chop; chop;
		push (@{$self->{FORM}->{$key}},$_);
	    }
	}
    }
    for (keys(%{$self->{FORM}})) {
	if (ref($self->{FORM}->{$_}) eq "ARRAY") {
	    $self->{FORM}->{$_} = join("\n",@{$self->{FORM}->{$_}});
	}
    }
}
1;

# ToDo: chop "\r\n" from uploaded files

# Local Variables:
# mode: cperl
# End:
