#!/usr/bin/perl -w
#$Header: /data/cvs/mtx/application/web-config/var/www/cgi-bin/CWeb/TemplProc.pm,v 1.1 2004/05/26 12:03:19 br1 Exp $

package CWeb::TemplProc;
use Exporter;
push @ISA, "Exporter";
@EXPORT_OK = qw{process_template};

sub new {
    my $proto = shift;
    $class = ref($proto) || $proto;
    my $self = {};
    print "Content-type: text/html\n\n";
    bless($self,$class);
}

sub process_template {
  my $self = shift;
  my $file = ref($self) eq __PACKAGE__ ? shift : $self;
  my $vars = shift;
  local (*FILE);

  open(FILE,$file) ||  do {
    warn "can't open file $file\n";
    return("EOF");
  };

  while (<FILE>) {
    line_handler($_,$vars,\*FILE);
  }
}

sub line_handler {
  local ($_) = shift;
  my $vars = shift;
  local (*FILE) = shift;
  my $listcontext = shift;
 SWITCH: {
    /(.*)\<#(.*)#\>(.*)/ && do { perl_expression($1,$2,$3,$vars,$listcontext);
				 last SWITCH;
			       };
    /^#include\s+"(.+)"/i  && do { process_template($1,$vars);
				   last SWITCH;
				 };
    /^#list\s+(\w+)/i && do { process_list($1,\*FILE,$vars);
			      last SWITCH;
			      };
    print subst_vars($_,$vars,$listcontext);
  }
}

sub subst_vars {
  my $notation = shift;
  my $vars = shift;
  my $listcontext = shift;
  my ($head,$expr,$tail);
  while($notation =~ /^(.*)\$\{([^\}]+)\}(.*)/) {
    ($head,$expr,$tail) = ($1,$2,$3);
    $expr =~ s/\*./$listcontext\./g if defined $listcontext;
    if (defined $vars) {
      $notation = $head . expand($expr,$vars) . $tail;
    } else {
      $notation = $head . trans($expr) . $tail;
    }
  }
  $notation
}

sub trans {
  my $string = shift;
  $string =~ s/^([^.]+)/\{$1\}/;
  $string =~ s/\.(\w+)/->\{$1\}/g;
  "\$vars->$string";
}

sub expand {
  my $string = shift;
  my $ref = shift;
  while ($string =~ /^([^.]+).?(.*)/) {
    $string = $2;
    $ref = $ref->{$1};
  }
  $ref;
}


sub process_list {
  my $list = shift;            # list-name
  my $handle = shift;          # file handle to read from
  my $vars = shift;            # variable hash
  my @body = ();               # list body from template
  print "\n<!-- processing list $list -->\n\n";
  while(<$handle>) {
    last if /^#listend/i;
    push @body, $_;
  }
  my $key;
  foreach $key (sort {$a <=> $b} keys(%{expand($list,$vars)})) {
    if (ref(expand("$list.$key",$vars))) {
    	map {line_handler($_,$vars,$handle,"$list.$key")} @body;
    }
  }
}

sub perl_expression {
  my $head = shift;
  my $eval = shift;
  my $tail = shift;
  my $vars = shift;
  my $listcontext = shift;
  print(subst_vars($head,$vars,$listcontext),
	eval subst_vars($eval,undef,$listcontext),
	subst_vars($tail,$vars,$listcontext));
}

#Local Variables:
#mode: cperl
#End:
