#!/usr/bin/perl -w
#$Header: /data/cvs/mtx/application/web-config/var/www/cgi-bin/CWeb/Tools.pm,v 1.1 2004/05/26 12:03:19 br1 Exp $

package CWeb::Tools;
use Exporter;
use POSIX;
# use strict;

push our @ISA, "Exporter";
our @EXPORT_OK = qw{ print_ip
		 split_ip
		 ip_part
		 tmp_config
		 };

sub new {
	my $proto = shift;
	my $class = ref($proto) || $proto;
	my $self = {};
	bless($self,$class);
}

sub print_ip {
	my $self = shift;
	my $arg1 = ref($self) eq __PACKAGE__ ? shift : $self;
	my $arg2 = shift;
	my $arg3 = shift;
	my $arg4 = shift;
	if ($arg1 ne "" && $arg2 ne "" && $arg3 ne "" && $arg4 ne "") {
		return "$arg1.$arg2.$arg3.$arg4";
	} else {
		return "";
	}
}

sub split_ip {
	my $self = shift;
	my $arg1 = ref($self) eq __PACKAGE__ ? shift : $self;
	my $arg2 = shift;
	my $i=1;
	my $hash = {};

	foreach (split /\./, $arg1) {
		$hash->{"$arg2$i"} = $_;
		$i++;
	}
	return $hash;
}

sub ip_part {
	my $self = shift;
	my $arg1 = ref($self) eq __PACKAGE__ ? shift : $self;
	my $no = shift;
	$arg1 =~ /(\w*)\.(\w*)\.(\w*)\.(\w*)/;
	return eval "$$no";
}

sub tmp_config {
  my $self = shift;
  my $path = ref($self) eq __PACKAGE__ ? shift : $self;
  $path =~ s+.*/++;
  "/tmp/$path";
}

sub array2hash {
  my $self = shift;
  my $array = ref($self) eq __PACKAGE__ ? shift : $self;
  return(pop(@$array)) unless $#{$array} or $_[0]; # 2nd arg -> "force";
  my $hash = {};
  my $i = 1;
  foreach (@$array) {
    $hash->{$i++} = $_;
  }
  $hash;
}

sub hash2array {
  my $self = shift;
  my $hash = ref($self) eq __PACKAGE__ ? shift : $self;
  return($hash) unless ref($hash) =~ /HASH/;
  my @a = ();
  foreach (sort {$a <=> $b} keys(%$hash)) {
    push(@a,$hash->{$_}) if ($_ * 1); #eg. "numeric" indexes
  }
  @a;
}

sub strip {
	my $self = shift;
  	my $a = ref($self) eq __PACKAGE__ ? shift : $self;
	$a =~ s/\s+$//;
	$a =~ s/^\s+//;
	return $a;
}

sub background_init {
  do {
    open(STDOUT,">>/tmp/restart.log");
    open(STDERR,">&STDOUT");
    open(STDIN,"/dev/null");
    POSIX::setsid();		#detach from shell-session
    print "***\n";
    foreach my $cmd (@{$_[1]}) {
      print "* running: ", $$cmd[0], " ";
      foreach my $p(@$cmd[1..$#{$cmd}]) {
      	print $p, " ";
      }
      print "\n";
      my $x = system(@$cmd);
      print "* exit: ", $x, "\n\n"
    }
    print "***\n\n";
    exit;
  } unless fork;
}

#Local Variables:
#mode: cperl
#End:
