#!/usr/bin/perl -w

#$Header: /data/cvs/mtx/application/web-config/var/www/cgi-bin/Config/IFace.pm,v 1.1 2004/05/26 12:03:19 br1 Exp $

package Config::IFace;

use Exporter;
use strict;
use CWeb::Tools;
#use Data::Dumper;

our @ISA =  "Exporter";
our @EXPORT_OK = qw{ read write parse_wireless_key print_wireless_key };

#-------------------------------------------------------------------
# generic "new" method for config file handlers
sub new {
	my $proto = shift;
	my $class = ref($proto) || $proto;
	my $cfg_file = shift;
	$cfg_file = "/etc/network/interfaces" unless defined $cfg_file;
	my $self = {_CONFIG_FILE => $cfg_file, _TOOL => new CWeb::Tools};
	bless($self,$class);
	$self->get_ifaceconfig();
	return $self;
}
#-------------------------------------------------------------------

sub read {
	my $self = shift;
	my $conffile;
	# config-file from object,- unless called as module-function
	if (ref($self) eq __PACKAGE__) {
		$conffile = $self->{_CONFIG_FILE};
	} else { # fake it ;-)
		$conffile = $self;
		$self = {_TOOL => new CWeb::Tools}; bless{$self};
	}
	#print Dumper($self);
	my $vars = {};
	open(VARS,$conffile) || warn "can't open config file $conffile\n";
	while (<VARS>) {
		SWITCH: {
		/^auto/ && do { $vars->{"auto"} = auto($vars->{"auto"},\*VARS,$_);
			last SWITCH;
		};
		/^iface/ && do {$vars->{"Interface"} = {} unless defined $vars->{"Interface"};
			$vars->{"Interface"} = {
				%{$vars->{"Interface"}},
				%{iface(\*VARS,$_)},
			};
			last SWITCH;
		};
		/^mapping/ && do { $vars->{"Mapping"} = {}
			unless defined $vars->{"Mapping"};
			$vars->{"Mapping"} = {
				%{$vars->{"Mapping"}},
				%{mapping(\*VARS,$_)}
			};
			last SWITCH;
		};
		}
	}
	$vars;
}

sub auto {
	my $vars = shift;
	my $fhandle = shift;
	my $line1 = shift;
	my $i = 0;
	if (defined($vars)) {
		@_ = sort { $a <=> $b } keys(%$vars);
		$i = pop(@_); $i++;                     # this is a "max()" ;-)
	}
	$line1 =~ s/^auto\s+//;
	foreach (split(/\s+/,$line1)) {
		$vars->{$i++} = $_;
	}
	$vars;
}

sub iface {
	my $fhandle = shift;
	my $line1 = shift;
	my $vars = {};
	my $name;
	if ($line1 =~ /^iface\s+(\S+)\s+(\S+)\s+(\S+)/) {
		$name = $1;
		(
			$vars->{$name}->{NAME},
			$vars->{$name}->{AFM},
			$vars->{$name}->{METHOD}) = ($1,$2,$3);
	}
	while(<$fhandle>) {
		last if /^\s*$/;
		s/^\s+//;
		if (/hwaddress\s+(.*)/) {
			(
				$vars->{$name}->{HWADDRESS}->{CLASS},
				$vars->{$name}->{HWADDRESS}->{ADDRESS},
			) = split(/\s+/,$1);
		} else {
			/(\S+)\s+(.*)/ && do {
				my ($key,$value) = ($1,$2);
				$value =~ s/\s+$//;
				$vars->{$name}->{$key} = $value};
		}
	}
	$vars;
}

sub mapping {
	my $fhandle = shift;
	my $line1 = shift;
	my $vars = {};
	my @names;
	if ($line1 =~ /mapping\s+(.*)/i) {
		@names = split(/\s+/,$1);
	} else {
		warn "interfaces unknow, aborting\n";
		return(0);
	}
	while(<$fhandle>) {
		last if /^\s*$/;
		s/^\s+//;
		my @f = split(/\s+/);
		foreach my $n (@names) {
			if ($f[0] =~ /map/i) {
				$vars->{$n}->{MAP}->{$f[1]} = $f[2];
			} else {
				$vars->{$n}->{$f[0]} = $f[1];
			}
		}
	}
	$vars;
}

sub write {
	my $self = shift;
	# config-file from object,- unless called as module-function
	my $conffile;
	if (ref($self) eq __PACKAGE__) {
		$conffile = $self->{_CONFIG_FILE};
	} else { # fake it ;-)
		$conffile = $self;
		$self = {_TOOL => new CWeb::Tools}; bless($self);
	}

	my $vars = shift;

	my $newfile = $self->{_TOOL}->tmp_config($conffile);
	open(OSTDOUT,">&STDOUT");
	open(STDOUT,">$newfile") || die "can't write to $newfile\n";
	foreach ("auto","Mapping","Interface") {
		if (defined($vars->{$_})) {
			SWITCH: {
				/auto/ && do { print(join(" ",
							"auto",
							values(%{$vars->{$_}})),
						"\n\n");
					last SWITCH;
				};
				/Mapping/ && do { foreach my $if (keys(%{$vars->{Mapping}}))
					{ print "mapping $_\n";
						print("    script ",
							$vars->{Mapping}->{$_}->{script},
							"\n")
						if defined $vars->{Mapping}->{$_}->{script};
						foreach my $map (keys(%{$vars->{Mapping}->{$if}->{MAP}}))
						{print("    map ",$map, " ",
								$vars->{Mapping}->{$if}->{MAP}->{$map},
								"\n");
						};
						print "\n";
					}
					last SWITCH;
				};
				/Interface/ && do { foreach my $if (sort(keys(%{$vars->{Interface}})))
					{ my $t = $vars->{Interface}->{$if};
						print "iface $if $t->{AFM} $t->{METHOD}\n";
						foreach (sort(keys(%$t))) {
							CASE: {
								/HWADDERSS/ && do {
									print("    hwaddress ",
										$t->{HWADDRESS}->{CLASS},
										" ",
										$t->{HWADDRESS}->{ADRESS},
										"\n");
									last CASE;
								};
								/AFM|METHOD|NAME/ && do {last CASE};
								s/\s+$//;
								print("    $_ $t->{$_}\n") if $t->{$_};
							}
						}
						print "\n";
					}
					last SWITCH;
				};
				warn "unknown entry: $_\n";
			}
		}
	}
	open(STDOUT,">&OSTDOUT");
	$_ = `cat $newfile > $conffile`;
}

sub services_to_reload {

#	`ifdown iface0; ifup iface0`
#	`/etc/init.d/hostap-params restart`

#	if ( $oldip ne $vars->{"iface"}->{$ifaceif}->{"address"} ||
#	     $oldgw ne $vars->{"iface"}->{$ifaceif}->{"gateway"} ) {
#		`/etc/init.d/ipsec restart`
#	}
}

sub parse_wireless_key {
	my $self = shift;
	my $wireless_key = ref($self) eq __PACKAGE__ ? shift : $self;
	my @keys = split( /key\s?/, $wireless_key);
	my $vars = {};
	foreach (@keys) {
		if (/(\S+)\s+\[(.+)\]/) {
			$vars->{"key$2"} = $1;
		}
		if (/^\s*\[(.+)\]/) {
			$vars->{"defaultkey"} = $1;
		}
		if (/(restricted|open)/) {
			$vars->{"auth"} = $1;
		}
	}
	return $vars;
}

sub print_wireless_key {
	my $self = shift;
	my $wep1 = ref($self) eq __PACKAGE__ ? shift : $self;
	my $wep2 = shift;
	my $wep3 = shift;
	my $wep4 = shift;
	my $defaultkey = shift;
	my $auth = shift;

	my $return="";
	if (!$wep1 && !$wep2 && !$wep3 && !$wep4) {
		$return = "off";
	} else {
		# at least one key is set
		$return = "$wep1 [1]" if ($wep1);
		$return = "$return key $wep2 [2]" if ($wep2);
		$return = "$return key $wep3 [3]" if ($wep3);
		$return = "$return key $wep4 [4]" if ($wep4);
		if ( $defaultkey  <= 4 && eval ("\$wep$defaultkey") ) {
			$return = "$return key [$defaultkey]";
		}
		$return = "$return key $auth" if ($auth);
		$return =~ s/^key //;
	}
	$return;
}

# Returns a list with all existing interfaces
sub get_interfaces {
	my $self = shift;
	open INFILE, "ifconfig -a |";
	my @iface = grep {$_ = $1 if /^(\S+)/} <INFILE>;
	return @iface;
}

# Sets the logical interface-names, depending on the physical interfaces
# (Can only handle up to two cards right now)
# todo: Replace with more elegant version, using bitlogic and stuff
sub get_ifaceconfig {
	my $self = shift;
	$self->{'client_if'} = "";
	$self->{'mesh_if'} = "";
	my @iface = $self->get_interfaces();
	my %iface;
	foreach (@iface) {
		$iface{$_} = 1;
	}
	# Check for combinations of interfaces
	my $atheros_cards = 0;
	my $prism_cards = 0;
	if ($iface{'ath0'}) {++$atheros_cards;}
	if ($iface{'ath1'}) {++$atheros_cards;}
	if ($iface{'wlan0'}) {++$prism_cards;}
	if ($iface{'wlan1'}) {++$prism_cards;}
	if ($atheros_cards > 0 && $prism_cards == 0) {
		# Atheros only
		$self->{'client_if'} = "ath0";
		if ($iface{'ath1'}) {
			$self->{'mesh_if'} = "ath1";
		}
	}
	if ($atheros_cards == 0 && $prism_cards > 0) {
		# Prism only
		$self->{'client_if'} = "wlan0";
		if ($iface{'wlan1'}) {
			$self->{'mesh_if'} = "wlan1";
		}
	}
	if ($atheros_cards > 0 && $prism_cards > 0) {
		# Atheros and Prism mixed
		# Hardwired: Use Atheros for meshing, Prism for clients
		$self->{'client_if'} = "wlan0";
		$self->{'mesh_if'} = "ath0";
	}
}

sub get_clientif {
	my $self = shift;
	return $self->{'client_if'};
}

sub get_meshif {
	my $self = shift;
	return $self->{'mesh_if'};
}

1;

#Local Variables:
#mode: cperl
#End:
