#!/usr/bin/perl -w
#$HeadURL: http://gruen.4g/svn/branches/stable-1.0/application/nylon-config/srv/www/cgi-bin/Config/List.pm $ $Rev: 741 $

package Config::List;

BEGIN { push @INC , ".."; };

use CWeb::Tools;
use Exporter;
# use strict;
# use Data::Dumper;

our @ISA =  "Exporter";
our @EXPORT_OK = qw{ read write };

#-------------------------------------------------------------------
# generic "new" method for config file handlers
sub new {
  my $proto = shift;
  my $class = ref($proto) || $proto;
  my $cfg_file = shift;
  my $cols = shift;
  $cfg_file = "undefined.list" unless defined $cfg_file;
  my $self = { _CONFIG_FILE => $cfg_file,
	       _COLUMN_NAMES => $cols,  # may be undefined -> created in reader
	       _TOOL => new CWeb::Tools,
	     };
  bless($self,$class);
}
#-------------------------------------------------------------------

sub read {
  my $self = shift;
  # column-names from object,- unless called as module-function
  my ($cols,$conffile);
  # OO or plain module?
  if (ref($self) eq __PACKAGE__) {
    $cols =  $self->{_COLUMN_NAMES};
    $conffile = $self->{_CONFIG_FILE};
  } else {
    $cols =  shift;
    $conffile = shift;
  }
  my $vars = {};
  my $localvars = {};
  my @values;
  my $i=1;
  open(VARS,$conffile) || warn "can't open config file $conffile\n";
  while (<VARS>) {
    chomp;
    if (!/^#/) {
	@values = split(/\s+/);
	$localvars = {};
	my $col = 0;
	foreach (@values) {
	$$cols[$col] = "c$col" unless defined $$cols[$col]; # eg. "c1,c2,c3..."
	$localvars->{$$cols[$col++]} = $_;
	}
	if (@values) {
		$localvars->{"INDEX"} = $i;
		$vars->{SIZE} = $i;
		$vars->{$i++}=$localvars;
	}
     }
  }
  $self->{_COLUMN_NAMES} = $cols;
  $self->{VARS} = $vars;
  $vars;
}

sub write {
  my $self = shift;
  my ($cols,$conffile);
  # OO or plain module?
  if (ref($self) eq __PACKAGE__) {
    $cols =  $self->{_COLUMN_NAMES};
    $conffile = $self->{_CONFIG_FILE};
  } else {
    $cols =  shift;
    $conffile = shift;
  }

  my $vars = shift;
  my $newfile = $self->{_TOOL}->tmp_config($conffile);
  open(NEW,">$newfile") || die "can't write to $newfile\n";

  my @line;
  foreach my $key (sort  {$a <=> $b} keys(%$vars)) {
    @line = ();
    foreach (@$cols) {
      next unless ref($vars->{$key});
      push(@line,$vars->{$key}->{$_});
    }
    print NEW join("\t",@line),"\n" if @line;
  }
  close NEW;
  $_ = `cat $newfile > $conffile`;
}

#Local Variables:
#mode: cperl
#End:
