#!/usr/bin/perl -w
#$Header: /data/cvs/mtx/application/web-config/var/www/cgi-bin/Config/Resolv.pm,v 1.1 2004/05/26 12:03:19 br1 Exp $

package Config::Resolv;

use Exporter;
# use strict;

our @ISA =  "Exporter";
our @EXPORT_OK = qw{ read write };

#-------------------------------------------------------------------
# generic "new" method for config file handlers
sub new {
  my $proto = shift;
  my $class = ref($proto) || $proto;
  my $cfg_file = shift;
  $cfg_file = "/etc/resolv.conf" unless defined $cfg_file;
  my $self = { _CONFIG_FILE => $cfg_file,
	     };
  bless($self,$class);
}
#-------------------------------------------------------------------

sub read {
  my $self = shift;
  # config-file from object,- unless called as module-function
  my $file = ref($self) eq __PACKAGE__ ? $self->{_CONFIG_FILE} : shift;

  my $vars = {};
  my $i=1;
  open(VARS,$file) || warn "can't open config file $file\n";
  while (<VARS>) {
    if (/(\w*)\s*(\S*)/) {
      my ($name, $value) = ($1,$2);
      if ($name eq "nameserver") {
      		while (defined $vars->{"nameserver"}->{$i}) {
			 $i++;
      		}
		$vars->{"nameserver"}->{$i} = $value;
	}
	else {
      		$vars->{$name}=$value;
	}
    }
  }
  $vars;
}

sub write {
  my $self = shift;
  # config-file from object,- unless called as module-function
  my $conffile = ref($self) eq __PACKAGE__ ? $self->{_CONFIG_FILE} : shift;
  my $vars = shift;

  my ($newfile) = $conffile;
  $newfile =~ s+.*/++;
  $newfile = "/tmp/$newfile";
  open(NEW,">$newfile") || die "can't write to $newfile\n";

  foreach $key (keys %$vars) {
	if ($key eq "nameserver") {
		$nameserver = $vars->{"nameserver"};
		foreach $ns (values %$nameserver) {
			if ($ns) {
				print NEW "nameserver $ns\n";
			}
		}
	}
	else {
		print NEW "$key $vars->{$key}\n";
	}
    }

  close NEW;
  $_ = `cat $newfile > $conffile`;
}

#Local Variables:
#mode: cperl
#End:
