#!/usr/bin/perl -w
#$HeadURL: http://gruen.4g/svn/branches/stable-1.0/application/nylon-config/srv/www/cgi-bin/Config/Sh.pm $ $Rev: 748 $

package Config::Sh;

use Exporter;
# use strict;

our @ISA =  "Exporter";
our @EXPORT_OK = qw{ read write };

#-------------------------------------------------------------------
# generic "new" method for config file handlers
sub new {
  my $proto = shift;
  my $class = ref($proto) || $proto;
  my $cfg_file = shift;
  $cfg_file = "/etc/bladeldudel.cfg" unless defined $cfg_file;
  my $self = { _CONFIG_FILE => $cfg_file,
	     };
  bless($self,$class);
}
#-------------------------------------------------------------------

sub read {
  my $self = shift;
  # config-file from object,- unless called as module-function
  my $file = ref($self) eq __PACKAGE__ ? $self->{_CONFIG_FILE} : shift;

  my $vars = {};
  open(VARS,$file) || warn "can't open config file $file\n";
  while (<VARS>) {
    if (/\s*([^=\s]+)\s*=\s*(.*)/) {
      my ($name, $value) = ($1,$2);
      $value =~ s/(.*)#.*/$1/;
      $value =~ s/\s+$//;
      $value =~ s/['"](.*)['"]/$1/;
      $vars->{$name}=$value;
    }
  }
  $self->{VARS} = $vars;
  $vars;
}

sub write {
  my $self = shift;
  # config-file from object,- unless called as module-function
  my $conffile = ref($self) eq __PACKAGE__ ? $self->{_CONFIG_FILE} : shift;
  my $vars = shift;

  my ($newfile) = $conffile;
  $newfile =~ s+.*/++;
  $newfile = "/tmp/$newfile";
  open(NEW,">$newfile") || die "can't write to $newfile\n";
  open(CNF,$conffile) || die "can't read from $conffile\n";

  my $comment;
  while(my $line = <CNF>) {
    chomp $line;
    $comment = '';
    ($line, $comment) = ($1,$2) if $line =~ /(.*)(\#.*)/;
    if ($line =~ /(\s+)$/) {
      $comment = $1 . $comment;
      $line =~ s/\s+$//;
    }
    if ($line =~ /(\s*)([^=\s]+)(\s*)=(\s*)(\w+|['"][^'"]*['"])/) {
      my ($head,$key,$ws1,$ws2,$oldval,$quote) = ($1,$2,$3,$4,$5,'');
      $quote = $1 if $oldval =~ /^(['"])/;
      if (defined($vars->{$key})) {
	print NEW "$key$ws1=$ws2$quote$vars->{$key}$quote$comment\n";
      } else {
	print NEW "$line$comment\n";
      }
    } else {  #doesn't match KEY = VALUE
      print NEW "$line$comment\n";
    }
  }
  close CNF; close NEW;
  $_ = `cat $newfile > $conffile`;
}

#Local Variables:
#mode: cperl
#End:
