#!/usr/bin/perl -w

package Config::UHttpd;

use Exporter;
# use strict;

our @ISA =  "Exporter";
our @EXPORT_OK = qw{ read write };

#-------------------------------------------------------------------
# generic "new" method for config file handlers
sub new {
  my $proto = shift;
  my $class = ref($proto) || $proto;
  my $cfg_file = shift;
  $cfg_file = "/etc/httpd.conf" unless defined $cfg_file;
  my $self = { _CONFIG_FILE => $cfg_file,
	     };
  bless($self,$class);
}
#-------------------------------------------------------------------

sub read {
  my $self = shift;
  # config-file from object,- unless called as module-function
  my $file = ref($self) eq __PACKAGE__ ? $self->{_CONFIG_FILE} : shift;

  my $vars = {};
  open(FILE,$file) || warn "can't open config file $file\n";
  while (<FILE>) {
    if (/^A:(\S*)/) {
     	$vars->{"allow"} = $1;
    }
    if (/^(\/[^:]*):([^:]*):([^:\s]*)/) {
	my $up = {};
	$up->{"user"} = $2;
	$up->{"passwd"} = $3;
	$vars->{$1} = $up;
    }
  }
  $vars;
}

sub write {
  my $self = shift;
  # config-file from object,- unless called as module-function
  my $conffile = ref($self) eq __PACKAGE__ ? $self->{_CONFIG_FILE} : shift;
  my $vars = shift;

  my ($newfile) = $conffile;
  $newfile =~ s+.*/++;
  $newfile = "/tmp/$newfile";
  open(NEW,">$newfile") || die "can't write to $newfile\n";

  foreach $key (keys %$vars) {
	if ($key eq "allow") {
		print NEW "A:$vars->{$key}\n";
	}
	else {
		print NEW "$key:$vars->{$key}->{'user'}:$vars->{$key}->{'passwd'}\n";
	}
    }

  close NEW;
  $_ = `cat $newfile > $conffile`;
}

#Local Variables:
#mode: cperl
#End:
