function error(text, name) {
	if (typeof name != "undefined" && name!="")
		text = name + ": " + text;
	alert(text);
}

//////////////// IP address validation //////////////// 

function ip0to255(x) {
	var d = parseInt(x, 10);
	if (!(d<256 && d>=0)) {
		return false;
	}
	return true;
}

function ip0to254(x) {
	var d = parseInt(x, 10);
	if (!(d<255 && d>=0)) {
		return false;
	}
	return true;
}

function ip1to254(x) {
	var d = parseInt(x, 10);
	if (!(d<255 && d>0)) {
		return false;
	}
	return true;
}

function ip1to255(x) {
	var d = parseInt(x, 10);
	if (!(d<256 && d>0)) {
		return false;
	}
	return true;
}

function ipequal(x1,x2,x3,x4,y1,y2,y3,y4) {
	if (	parseInt(x1) == parseInt(y1) &&
		parseInt(x2) == parseInt(y2) &&
		parseInt(x3) == parseInt(y3) &&
		parseInt(x4) == parseInt(y4) ) {
		return true;
	}
	return false;
}

function ip2int( x1, x2, x3, x4 ) {
	return parseInt(x1) * 256*3 + parseInt(x2) * 256*2 +
		parseInt(x3) * 256 + parseInt(x4);
}
		
function ipsmaller(x1,x2,x3,x4,y1,y2,y3,y4) {
	var x = ip2int( x1, x2, x3, x4);
	var y = ip2int( y1, y2, y3, y4);
	return x<y ? true : false;
}

function checkipaddress(fx1,fx2,fx3,fx4,name) {
	var x1 = fx1.value;
	var x2 = fx2.value;
	var x3 = fx3.value;
	var x4 = fx4.value;
	if (x1 == "" && x2 == "" && x3 == "" && x4 == "") {
		// allow totally empty IP fields (all 4)
		return true;
	}
	if (x1 == "" || x2 == "" || x3 == "" || x4 == "") {
		// but not partly empty
		error("IP Adressen knnen keine leeren Elemente haben!",name);
		return false;
	}
	if (	!ip1to254(x1) ||
		!ip0to255(x2) ||
		!ip0to255(x3) ||
		!ip1to254(x4)) {
			error("Keine gltige IP: " +x1+"."+x2+"."+x3+"."+x4, name);
			return false;
	}
	return true;
}

// simple check true if valid network address
function checkipnet(fx1,fx2,fx3,fx4) {
	var x1 = fx1.value;
	var x2 = fx2.value;
	var x3 = fx3.value;
	var x4 = fx4.value;
	if (x1 == "" && x2 == "" && x3 == "" && x4 == "") {
		// allow totally empty IP fields (all 4)
		return true;
	}
	if (x1 == "" || x2 == "" || x3 == "" || x4 == "") {
		// but not partly empty
		error("Netzwerk Adressen knnen keine leeren Elemente haben!",name);
		return false;
	}
	if (	!ip1to254(x1) ||
		!ip0to255(x2) ||
		!ip0to255(x3) ||
		!ip0to255(x4)) {
			error("Kein gltiges Netz: " +x1+"."+x2+"."+x3+"."+x4, name);
			return false;
	}
	return true;
}

// simple broadcast-address check without considering subnet-mask values
function checkipbroadcast(fx1,fx2,fx3,fx4,name) {
	var x1 = fx1.value;
	var x2 = fx2.value;
	var x3 = fx3.value;
	var x4 = fx4.value;
	if (x1 == "" && x2 == "" && x3 == "" && x4 == "") {
		// allow totally empty IP fields (all 4)
		return true;
	}
	if (x1 == "" || x2 == "" || x3 == "" || x4 == "") {
		// but not partly empty
		error("IP Broadcast-Adressen knnen keine leeren Elemente haben!",name);
		return false;
	}
	if (	!ip1to255(x1) ||
		!ip0to255(x2) ||
		!ip0to255(x3) ||
		!ip0to255(x4)) {
			error("Keine gltige Broadcast IP Adresse: " +x1+"."+x2+"."+x3+"."+x4, name);
			return false;
	}
	return true;
}

function checkipmask(fx1,fx2,fx3,fx4,name) {
	var x1 = fx1.value;
	var x2 = fx2.value;
	var x3 = fx3.value;
	var x4 = fx4.value;
	if (x1 == "" && x2 == "" && x3 == "" && x4 == "") {
		// allow totally empty IP fields (all 4)
		return true;
	}
	if (x1 == "" || x2 == "" || x3 == "" || x4 == "") {
		// but not partly empty
		error("IP Adressen knnen keine leeren Elemente haben!",name);
		return false;
	}
	if (	!this.ip0to255(x1) ||
		!this.ip0to255(x2) ||
		!this.ip0to255(x3) ||
		!this.ip0to255(x4)) {
			error("Keine gltige IP: " +x1+"."+x2+"."+x3+"."+x4,name);
			return false;
	}
	return true;
}

function checkipsmaller(fx1,fx2,fx3,fx4,fy1,fy2,fy3,fy4,name) {
	var x1 = fx1.value;
	var x2 = fx2.value;
	var x3 = fx3.value;
	var x4 = fx4.value;
	var y1 = fy1.value;
	var y2 = fy2.value;
	var y3 = fy3.value;
	var y4 = fy4.value;
	var xempty=0;
	var yempty=1;
	if (x1 == "" && x2 == "" && x3 == "" && x4 == "" && y1 == "" && y2 == "" && y3 == "" && y4 == "") {
		// allow totally empty IP fields (both IPs)
		return true;
	}
	if (x1 == "" || x2 == "" || x3 == "" || x4 == "" || y1 == "" || y2 == "" || y3 == "" || y4 == "") {
		// but not partly empty
		error("IP Adressen knnen keine leeren Elemente haben!",name);
		return false;
	}
	if (!ipsmaller(x1,x2,x3,x4, y1,y2,y3,y4)) {
		error( "IP1 nicht kleiner als IP2",name);
		return false;
	}
	return true;
}
	
//////////////// MAC address validation //////////////// 

function isHEX(x) {
	for (i = 0; i < x.length-1; ++i) {
		if (!(x.charAt(i) == '0' ||
			x.charAt(i) == '1' ||
			x.charAt(i) == '2' ||
			x.charAt(i) == '3' ||
			x.charAt(i) == '4' ||
			x.charAt(i) == '5' ||
			x.charAt(i) == '6' ||
			x.charAt(i) == '7' ||
			x.charAt(i) == '8' ||
			x.charAt(i) == '9' ||
			x.charAt(i) == 'A' || x.charAt(i) == 'a' ||
			x.charAt(i) == 'B' || x.charAt(i) == 'b' ||
			x.charAt(i) == 'C' || x.charAt(i) == 'c' ||
			x.charAt(i) == 'D' || x.charAt(i) == 'd' ||
			x.charAt(i) == 'E' || x.charAt(i) == 'e' ||
			x.charAt(i) == 'F' || x.charAt(i) == 'f' ) ) {
			return false;
		}
	}
	return true;
}

function isMACDelimiter(x) {
	if (x != ":") {
		return false;
	}
	return true;
}

function checkMAC(fa,name) {
	var a = fa.value;
	if (isHEX(a.substr(0,2)) &&
		isMACDelimiter(a.substr(2,1)) &&
		isHEX(a.substr(3,2)) &&
		isMACDelimiter(a.substr(5,1)) &&
		isHEX(a.substr(6,2)) &&
		isMACDelimiter(a.substr(8,1)) &&
		isHEX(a.substr(9,2)) &&
		isMACDelimiter(a.substr(11,1)) &&
		isHEX(a.substr(12,2)) &&
		isMACDelimiter(a.substr(14,1)) &&
		isHEX(a.substr(15,2)) ) {
		return true;
	}
	error("Keine MAC Addresse",name);
	return false;
}


//////////////// wlan parameters ////////////////

function checkrts(x,name) {
	if (!(x <= 2346 && x >= 0)) {
		error("RTS Threshold nicht im gltigen Bereich [0 - 2346]", name);
		return false;
	}
	return true;
}

function checkfragmentation(x,name) {
	if (!(x <= 2346 && x >= 0)) {
		error("Fragmentation Threshold nicht im gltigen Bereich [0 - 2346]",name);
		return false;
	} else if ( !(x % 2 == 0) ) {
		error("Fragmentation Threshold darf nur eine gerade Zahl sein",name);
		return false;
	}		
	return true;
}

function checkbeaconinterval(x,name) {
	if (!(x <= 1000 && x >= 1)) {
		error("Beacon Interval nicht im gltigen Bereich [1 - 1000]",name);
		return false;
	}	
	return true;
}

function checkdtiminterval(x) {
	if (!(x <= 65535 && x >= 1)) {
		error("DTIM Interval nicht im gltigen Bereich [1 - 65535]",name);
		return false;
	}	
	return true;
}


//////////////// other stuff ////////////////

function checkport(x,name) {
	var d = parseInt(x, 10);
	if (!( d<65536 && d>=0)) {
		error("Port Wert nicht im gltigen Bereich [0 - 65535]",name);
		return false;
	}
	return true;
}
